c     pbxio.f(or)   starts      ---------------------------------------|
C     -                                                                |
C     -                                                                |
c
      SUBROUTINE Giruzzi
#include "Implic.inc"
#include "params.inc"
#include "DqlBins.inc"
#include "FeBins.inc"
#include "ProfBody.inc"
#include "RayWrk.inc"
#include "RayBins.inc"
#include "WkAry.inc"
      INTEGER iv, ip, iNotSmoo, iYesSmoo, ipstep, ThisPlot, NumPlts
      INTEGER iFullFe, iOrigMaxwl
      DATA iNotSmoo, iYesSmoo / 1 , 2 /

      CHARACTER*1 curve, dots, altdots
      CHARACTER*10 chip
      DATA curve, dots,altdots, NumPlts  / ' ', '.', ',', 12 /
      ipstep = (npsi - 2)/NumPlts
      iv = 1
        iFullFe    = iITR
        iOrigMaxwl = mod(iITR,2) + 1
      ThisPlot = 1
      do 10 ip = ipstep, ipstep*NumPlts, ipstep
c     .                                 if chip starts with a 'l' or 'L'
c     .                                 then the logarithm is plotted
        write(chip,'(''Dql('',i2,'')'')') ip
c
c     .                                 call the curve line first... this
c     .                                 sets the scale of the graph
        call Dql6Norm(Vpar(iv),Dql(iv,ip,iYesSmoo),nv,
     ^                chip,curve, ThisPlot, NumPlts)
c     .                                 call the dots second....previous scale
c     .                                 will be used, and curve clipped if
c     .                                 necessary
        call Dql6Norm(Vpar(iv),Dql(iv,ip,iNotSmoo),nv,
     ^                chip,dots , ThisPlot, NumPlts)
c
        ThisPlot = ThisPlot + 1 
c
 10   continue


      iv = 1
      ThisPlot = 1
      do 20 ip = ipstep, ipstep*NumPlts, ipstep
c     .                                 if chip starts with a 'l' or 'L'
c     .                                 then the logarithm is plotted
        write(chip,'(''logFe ('',i2,'')'')') ip
c
c     .                                 call the curve line first... this
c     .                                 sets the scale of the graph
        call Dql6Norm(Vpar(iv),fe(iv,ip,iFullFe),nv,
     ^                chip,curve, ThisPlot, NumPlts)
c     .                                 call the dots second....previous scale
c     .                                 will be used, and curve clipped if
c     .                                 necessary
        call Dql6Norm(Vpar(iv),fe(iv,ip,iOrigMaxwl),nv,
     ^                chip,dots , ThisPlot, NumPlts)
c
        ThisPlot = ThisPlot + 1 
c
 20   continue


      return
      END
c
c     -----------------------------------------------------------------| 
c
      SUBROUTINE Dql6Norm (x, y, NumPts, chrst10, GrTyp,
     ^                                               ThisPlot, TotlPlts)
#include "Implic.inc"
#include "tscunits.inc"
      CHARACTER*1 GrTyp
      INTEGER MAXPts, n
      INTEGER NumPts, ThisPlot, TotlPlts, PltsOnPg, PltIndx
      INTEGER FirstInFrame
      PARAMETER (PltsOnPg =6)
      PARAMETER (MAXPts = 451)
      REAL     x(NumPts),  y(NumPts)
      REAL                yg(MAXPts)
      CHARACTER*10 chrst10
      INTEGER i, iCross0, iydiv(2), iyinv(2), iyldiv, iylinv
      INTEGER xlow(PltsOnPg) , xhigh(PltsOnPg),
     ^        ylow(PltsOnPg) , yhigh(PltsOnPg), ywrit(PltsOnPg)

      INTEGER ixlo(PltsOnPg) , ixhig(PltsOnPg),
     ^        iylo(PltsOnPg) , iyhig(PltsOnPg)

      INTEGER ytitl
      REAL    xmin, xmax, ymin(2), ymax(2), ylmn, ylmx
      REAL    ymnVal, ymxVal
      CHARACTER*1 logtest
      CHARACTER*24 MyString
      CHARACTER*30 TSCstring
      DATA     xmin    , xmax , ymnVal, ymxVal /
     ^          -1.0   ,  1.0 ,    0.0,    1.0 /
      DATA     ymin(1) , ymin(2) , ymax(1) , ymax (2) , ylmn , ylmx /
     ^           0.0   ,  -2.0   ,  1.5    ,   2.0    ,  -5.0,  1.0 /
      DATA     iydiv(1), iydiv(2), iyinv(1), iyinv(2), iyldiv, iylinv /
     ^            3    ,   2     ,   1     ,   2     ,    6  ,    1   /
      DATA    (xlow(i) , i=1,PltsOnPg) 
     ^       / 50,      400,      750,       50,      400,      750  /
      DATA    (xhigh(i), i=1,PltsOnPg) 
     ^    /   300,      650,     1000,      300,      650,     1000  /
      DATA    (ylow(i) , i=1,PltsOnPg) 
     ^      / 400,      400,      400,        50,      50,       50  /
      DATA   (yhigh(i) , i=1,PltsOnPg) 
     ^      / 650,      650,      650,       300,     300,      300  /
      DATA   (ywrit(i) , i=1,PltsOnPg) 
     ^      / 660,      660,      660,       310,     310,      310  /
      DATA    ytitl   / 725 /

      DATA    (ixlo(i) , i=1,PltsOnPg) 
     ^       /  0,      340,      680,        0,      340,      680  /
      DATA    (ixhig(i), i=1,PltsOnPg) 
     ^    /   340,      680,     1020,      340,      680,     1020  /
      DATA    (iylo(i) , i=1,PltsOnPg) 
     ^      / 380,      380,      380,         0,       0,        0  /
      DATA   (iyhig(i) , i=1,PltsOnPg) 
     ^      / 760,      760,      760,       380,     380,      380  /

c
      PltIndx = mod(ThisPlot-1, PltsOnPg) + 1
      if (GrTyp .eq. ' ' .or. GrTyp .eq. '-' .or.
     ^    GrTyp .eq. 'l' .or. GrTyp .eq. 'x' .or. GrTyp .eq. '|') then
          FirstInFrame = 1
        else
          FirstInFrame = 0
      endif

      if (ThisPlot .eq. 1 .and. FirstInFrame .eq. 1 ) then
         call EZinit
         call GNinit(nTSCgraf)
      endif
      n = NumPts
      if (n .gt. MAXPts) n = MAXPts
      logtest = chrst10(1:1)
c

      if (FirstInFrame .eq. 1) then
        call EZnorm ( y, yg , ymnVal, ymxVal, n, iCross0 )
        write (MyString, '( a10,''/'', 1pe8.1,''$'')') chrst10, ymxVal
        call EZwrit(xlow(PltIndx), ywrit(PltIndx), MyString , 0, 0 )
        call GNtitl(                               MyString        )
        if (logtest .ne. 'l' .and. logtest .ne. 'L' ) then
          call EZsets ( xlow(PltIndx), xhigh(PltIndx), 
     ^                  ylow(PltIndx), yhigh(PltIndx),
     ^                  xmin,           xmax, 
     ^                  ymin(iCross0),   ymax(iCross0),    1 )

          call GNsets ( ixlo(PltIndx), ixhig(PltIndx), 
     ^                  iylo(PltIndx), iyhig(PltIndx),
     ^                  xmin,           xmax, 
     ^                  ymin(iCross0),   ymax(iCross0),    1 )

          if(GrTyp .eq. 'x') then
            call EZcros ( x  , yg , n )
            call GNcros ( x  , yg , n )
          else if(GrTyp .eq. '|') then
            call EZbars ( x  , yg , n ,'y')
            call GNbars ( x  , yg , n ,'y')
          else
            call EZcurv ( x  , yg , n )
            call GNcurD ( x  , yg , n )
          endif
          call EZaxes ( 1 , 10, iydiv(iCross0), iyinv(iCross0) )
        else
          do 10 i = 1, n
            yg(i) = alog10( abs(yg(i)) + 1.e-6 )
            if (yg(i) .lt. ylmn ) yg(i) = ylmn
            if (yg(i) .gt. ylmx ) yg(i) = ylmx
 10       continue
          call EZsets ( xlow(PltIndx), xhigh(PltIndx), 
     ^                  ylow(PltIndx), yhigh(PltIndx),
     ^                  xmin,           xmax, 
     ^                  ylmn          , ylmx             , 1 )

          call GNsets ( ixlo(PltIndx), ixhig(PltIndx), 
     ^                  iylo(PltIndx), iyhig(PltIndx),
     ^                  xmin,           xmax, 
     ^                  ylmn          , ylmx             , 1 )

          if(GrTyp .eq. 'x') then
            call EZcros ( x  , yg , n )
            call GNcros ( x  , yg , n )
          else if(GrTyp .eq. '|') then
            call EZbars ( x  , yg , n ,'y')
            call GNbars ( x  , yg , n ,'y')
          else
            call EZcurv ( x  , yg , n )
            call GNcurD ( x  , yg , n )
          endif
          call EZaxes ( 1 , 10, iyldiv, iylinv )
        endif

      else 
        if (logtest .ne. 'l' .and. logtest .ne. 'L' ) then
          do 20 i = 1, n
            yg(i) = y(i)/ymxVal
            if (yg(i) .gt. 1.48) yg(i) = 1.48
            if (yg(i) .lt. 0.02) yg(i) = 0.02
 20       continue
          call EZpnts ( x  , yg , n )
          call GNpntD ( x  , yg , n )
        else
          do 30 i = 1, n
            yg(i) = alog10( abs(y(i)/ymxVal) + 1.e-6 )
            if (yg(i) .lt. ylmn ) yg(i) = ylmn
            if (yg(i) .gt. ylmx ) yg(i) = ylmx
 30       continue
          call EZpnts ( x  , yg , n )
          call GNpntD ( x  , yg , n )
        endif
c
      endif
c     
c      
      if (( PltIndx .eq. PltsOnPg .or. ThisPlot .eq. TotlPlts ))then
      if ( FirstInFrame .eq. 0 .or. GrTyp .eq. 'x' 
     ^                         .or. GrTyp .eq. '|' ) then
        write(TSCstring,'( a10, '' vs v/c: page of 6  '')') chrst10
        call EZwrit(xlow(1),ytitl,
     ^                   TSCstring // '$' ,0,0) 
        call MkGrfLst( TSCstring )
        call EZfini(0,0)
        call GNfini
      endif
      endif
c
      return
      END
c
c     -----------------------------------------------------------------|
c
      SUBROUTINE vwrite(n, vec, name)
#include "tscunits.inc"
      CHARACTER *(*) name
      REAL     vec(n)
      call VecMnMx(vec, n, vmin, vmax)
      write(nLSCcom2, 100)name, n, vmin, vmax
 100  format(/, a ,/, ' n = ', i3 ,
     ^             /, ' min = ', g11.4 ,
     ^             /, ' max = ', g11.4)
      iout = 1
      if(n .lt. 5) then
         nby5 = 1
      else if(5 * (n / 5) .eq. n) then
         nby5 = n  / 5
      else
         nby5 = n / 5 + 1
      endif
      do 20 i = 1, nby5
         nout = n - iout + 1
         if(nout .gt. 5)then
            nout = 5
         endif
         write(nLSCcom2, 101)(vec(j), j = iout, iout + nout - 1)
 101     format(1pe10.3, 2x, 1pe10.3, 2x, 1pe10.3, 2x, 
     ^          1pe10.3, 2x, 1pe10.3                )
         iout = iout + nout
 20   continue
      write(nLSCcom2, 102)
 102  format(/)
      return
      END
c     -----------------------------------------------------------------| 
      SUBROUTINE viwrite(n, vec, name)
#include "tscunits.inc"
      CHARACTER *(*) name
      INTEGER vec, vmin, vmax
      DIMENSION vec(n)
      call VecIMnMx(vec, n, vmin, vmax)
      write(nLSCcom2, 100)name, n, vmin, vmax
 100  format(/, a, /, ' n = ', i3 ,/, ' min = ', i5 ,
     ^             /, ' max = ', i5)
      iout = 1
      if(n .lt. 5)then
              nby5 = 1
      else
              nby5 = n / 5
      endif
      do 20 i = 1, nby5
              nout = n - iout + 1
              if(nout .gt. 5)then
                      nout = 5
              endif
              write(nLSCcom2, 101)(vec(j), j = iout, iout + nout - 1)
 101          format(i5, 2x, i5, 2x, i5, 2x, i5, 2x, i5)
              iout = iout + nout
 20   continue
      write(nLSCcom2, 102)
 102  format(/)
      return
      END
c
c     -----------------------------------------------------------------| 
c
      SUBROUTINE EZrndu(r,x,i)
c      x is the nice graph max for plotting
c      i is the #of major divisions
#include "Implic.inc"
      INTEGER i, iexp
      REAL    r, x, a
      REAL    SmallNum
      real    RE41
      DATA    SmallNum / 0.00001 /
      x = abs ( r )
      i = 1
      if ( r .eq. 0. ) return
      a = alog10 ( x )
      RE41 = a
      iexp = ifix (RE41)
c     iexp = ifix ( a )
      iexp = 1 - iexp
      if ( a .lt. 0. ) iexp = iexp + 1
      x = x*(10.**iexp)
      if ( x .gt. 10. + SmallNum ) go to 20
      x = 10.
      i = 2
      go to 2000
20    if ( x .gt. 20. + SmallNum ) go to 50
      x = 20.
      i = 2
      go to 2000
50    if ( x .gt. 50. + SmallNum ) go to 100
      x = 50.
      i = 2
      go to 2000
100   x = 100.
      i  = 2
2000  x = x / (10.**iexp)
      x = sign (x,r)
      return
      END
c
c----------------------------------------------------------------------
c
      SUBROUTINE EZrnd2( r , x, i, ii )
#include "Implic.inc"
      INTEGER i, ii, iexp
      REAL    r, x, a, b
      REAL    SmallNum
      DATA    SmallNum / 0.00001 /
      real    RE41
C     r is the given maximum value to be graphed
C     x is the nice graph maximum for plotting
C     i  is the # of major divisions
C     ii is the # of minor divisions
C     Chosen maximum is one of 1 1.5 2 2.5 3 4 5 7.5 10 15 etc
 
      x = abs ( r )
      i = 1
      ii= 2
      if ( r .eq. 0. ) return
 
      a    = alog10 ( x )
      RE41 = a
      iexp = ifix (RE41)
c     iexp = ifix ( a )
      iexp = 1 - iexp
      if ( a .lt. 0. ) iexp = iexp + 1
      b = 10.0**  iexp  
      x = x*b
 
      if      ( x .le. 10. + SmallNum ) then
        x = 10.
        i = 2
        ii= 5
 
      else if ( x .le. 15. + SmallNum ) then
        x = 15.
        i = 3
        ii= 5
 
      else if ( x .le. 20. + SmallNum ) then
        x = 20.
        i = 2
        ii= 5
 
      else if ( x .le. 25. + SmallNum ) then
        x = 25.
        i = 5
        ii= 1
 
      else if ( x .le. 30. + SmallNum ) then
        x = 30.
        i = 3
        ii= 2
c!!     i = 2 & ii = 3 bring out a bug in sg such that the scale is screwed up
 
      else if ( x .le. 40. + SmallNum ) then
        x = 40.
        i = 2
        ii= 4
 
      else if ( x .le. 50. + SmallNum ) then
        x = 50.
        i = 2
        ii= 5
 
      else if ( x .le. 75. + SmallNum ) then
        x = 75.
        i = 3
        ii= 5
 
      else
        x = 100.
        i  = 2
        ii = 5
 
      endif
 
      x = x / b
      x = sign (x,r)
 
      return
      END
c
c----------------------------------------------------------------------
c
      SUBROUTINE EZnorm ( fin , fout , fmin , fmax , n , iCross0)
c     Takes a set of  n  values in fin and supplies a scaled array
c     in fout such that the maximum is unity, and supplies fmax as
c     that maximum value for information.
c
c     MAX ( fout ) =  1. 
c     MAX ( fin  ) =  fmax  =  fmax * MAX ( fout )
      
#include "Implic.inc"
      INTEGER n, i, iCross0
      REAL    fin(n) , fout(n) , fmin , fmax , temp

      fmax = fin(1)
      fmin = fin(1)
      do 10 i=2,n
        if (fmax .lt. fin(i) ) fmax = fin(i)
        if (fmin .gt. fin(i) ) fmin = fin(i)
 10   continue

      if (abs(fmin) .gt. abs(fmax) ) then
        temp = fmax
        fmax = fmin
        fmin = temp
      endif
      
      if (fmax .eq. 0.) then
        fmax = 1.
        fmin = 0.
      endif

      do 20 i=1,n
        fout(i) = fin(i)/fmax
 20   continue
      
      if (fmax * fmin .lt. 0.0 ) then
        iCross0 = 2
        else
        iCross0 = 1
      endif

      return
      END

c                                                                      |
c                                                                      |
c     pbxio.f(or)   ends        ---------------------------------------|

