c     Ramppwr.inc begins
c     NrampDIM  Max number of different power levels in the 
c               ramp up process aimed at iterating to f_e(v_\parallel)
c     
c     NrampUp   Num of ramp ups including the flat portion starting from
c                    a Maxwellian
c     Nflat     Num of iterations during the ramp which are flat
c     PwrLevel  Array of power levels. First increasing; then flat.

      INTEGER NRAMPDIM, NFLATDEF
      PARAMETER(NRAMPDIM = 200)
      PARAMETER(NFLATDEF =  10)
      INTEGER nRampUp, nFlat
      REAL pwrlevel(NRAMPDIM), FeCvgAry(NRAMPDIM)
      COMMON / rampc0 / nRampUp, nFlat
      COMMON / rampc1 / pwrlevel, FeCvgAry
c     Ramppwr.inc ends
