c     Rayio.F  begins                       ---------------------------|
c     -                                                                |
c     -                                                                |
c
c     WrRay     begins                      ---------------------------|
c     -                                                                |
c     -                                                                |
      SUBROUTINE WrRay
#include "Implic.inc"
#include "tscunits.inc"
#include "params.inc"
#include "Doflags.inc"
#include "RayBins.inc"
#include "TSCgrap.inc"
      CHARACTER*16 FileNa
      INTEGER i,j, nzThisRay
c
      if (DoTRAN .eq. 1) then
        FileNa = Equhd(1) // Equhd(2)            ! Transp Run ID // 'RAY.DAT'
        If (FileNa .Eq. ' ') FileNa = 'ray.dat'  ! NonTransp name
      else
        FileNa = 'ray.dat'
      endif
c
      open (nTSCunus,status='unknown',file = FileNa, err=1300)      
      write(nTSCunus,'('' nzones, nrays, npsi, iLastRy are: '')' )
      write(nTSCunus,'( 1x, 4i5 )' )  nzones, nrays, npsi, iLastRy
 
      do 10 j=1,nrays
        nzThisRay=nzones
        do 5 i=1,nzones
          if(ivind(i,j) .ne. 0) goto 5
          nzThisRay=i
          goto 6
 5      continue
 6      continue
      write(nTSCunus,
     ^     '(1x, i4, '' izind for ray number '', i4 )') nzThisRay,j
      write(nTSCunus,600)                (izind(i,j)  ,i=1,nzThisRay) 
      write(nTSCunus,
     ^     '(1x, i4, '' ivind for ray number '', i4 )') nzThisRay, j
      write(nTSCunus,600)                (ivind(i,j)  ,i=1,nzThisRay) 
      write(nTSCunus,'(
     ^ '' ezsq; npar; dlnPdsX; dlnPdsK for ray number '', i4 )') j
      write(nTSCunus,601)                 (ezsq(i,j)  ,i=1,nzThisRay)
      write(nTSCunus,601)                 (npar(i,j)  ,i=1,nzThisRay)
      write(nTSCunus,601)              (dlnPdsX(i,j)  ,i=1,nzThisRay)
      write(nTSCunus,601)              (dlnPdsK(i,j)  ,i=1,nzThisRay)  
 10   continue
 600  format( (20i4)    )
 601  format( (1x, 5e15.8) )
       
      close(nTSCunus)
      return
 1300 continue
      call LSCstop (' error opening file in WrRay')
      return
      END
c     -                                                                |
c     -                                                                |
c     WrRay     ends                        ---------------------------|
c
c     RdRay     begins                      ---------------------------|
c     -                                                                |
c     -                                                                |
      SUBROUTINE RdRay
#include "Implic.inc"
#include "tscunits.inc"
#include "params.inc"
#include "Doflags.inc"
#include "RayBins.inc"
#include "TSCgrap.inc"
      CHARACTER*16 FileNa, ch
      INTEGER i,j, nzThisRay
c
      if (DoTRAN .eq. 1) then
        FileNa = Equhd(1) // Equhd(2)            ! Transp Run ID // 'RAY.DAT'
        If (FileNa .Eq. ' ') FileNa = 'ray.dat'  ! NonTransp name
      else
        FileNa = 'ray.dat'
      endif
c
      open (nTSCunus,status='old',    file = FileNa, err=1300)      
      read (nTSCunus,'(a1)') ch
      read (nTSCunus,'( 1x, 4i5 )' )  nzones, nrays, npsi, iLastRy
 
      do 10 j=1,nrays
      read (nTSCunus,'(1x,i4,a1)') nzThisRay, ch
      read (nTSCunus,600)                (izind(i,j)  ,i=1,nzThisRay) 
      read (nTSCunus,'(1x,i4,a1)') nzThisRay, ch
      read (nTSCunus,600)                (ivind(i,j)  ,i=1,nzThisRay) 
      read (nTSCunus,'(a1)') ch
      read (nTSCunus,601)                 (ezsq(i,j)  ,i=1,nzThisRay)
      read (nTSCunus,601)                 (npar(i,j)  ,i=1,nzThisRay)
      read (nTSCunus,601)              (dlnPdsX(i,j)  ,i=1,nzThisRay)
      read (nTSCunus,601)              (dlnPdsK(i,j)  ,i=1,nzThisRay)  
 10   continue
 600  format( (20i4)    )
 601  format( (1x, 5e15.8) )
       
      close(nTSCunus)
      return
 1300 continue
      call LSCstop (' error opening file in RdRay')
      return
      END
c
c     -                                                                |
c     -                                                                |
c     RdRay     ends                        ---------------------------|
c
C     PlRay     begins                      ---------------------------|
C     -                                                                |
C     -                                                                |
 
      SUBROUTINE PlRay(iFillPsi)
#include "Implic.inc"
      EXTERNAL psisur, plasma2d
c
c     Screen size is 1024 points wide by 780 points high
c     Nominal location of graphs in the x or horizontal direction
c     -       is   50-300    400-650    750-1000
c     Nominal location of graphs in the y or vertical   direction
c     -       is   50-300    400-650
c
      CHARACTER*10 FileNa
      CHARACTER*30 MyString
      INTEGER i, igraph, inc, incin, incx, incxi,
     ^        ipol, ipoli, j, NPSISUR, Npts, iFillPsi
      INTEGER iDoAcces
      REAL    
     ^        ALPHA, Bpol, cosa, csx, csy, Cval, dR, dS, dZ,
     ^        niceMx,
     ^        parnx, pernx, PsiVal, Qval,
     ^        rmaxx, rminn, sina,  woc, Xpol, Xtor, zmaxx
      REAL
     ^                   r,z, psi,Br,Bz,RBphi,omc,Tee,pe2,pi2,aio,ael
      PARAMETER (NPSISUR = 3)
#include "params.inc"
#include "PIetc.inc"
#include "dielec.inc"
#include "tscunits.inc"
#include "Doflags.inc"
#include "FeBins.inc"
#include "RayBins.inc"
#include "RayWrk.inc"
#include "TSCgrap.inc"
#include "WkAry.inc"
c
      DATA  FileNa      /
     ^     'surf.dat'   /
      DATA  iDoAcces /1/
      INTEGER ipsisur, npsipts(NPSISUR), icross(4), nfound
      REAL     rpsi(NPSISUR,NPLTDIM), zpsi(NPSISUR,NPLTDIM)
      REAL     RRary(NPLTDIM), ZZary(NPLTDIM), ep
 
      DATA   ALPHA / 
     ^    0.523599 /
C     ALPHA = PI/6 = 0.52 for 30 degrees
c     parnx = 10 --> very heavy electron damping
c     pernx = 150--> synchronism with 40 kev D ions
      DATA parnx,pernx,igraph,inc,incin,incx,incxi /
     ^       10., 150.,     0,  2,    2,   2,    5 /
      REAL
     ^        ZERO, ONE, RE81, RE82, ONE80
      DATA ZERO, ONE, ONE80/
     ^      0.0, 1.0, 180. /
      if ( iplt .eq. NPLTDIM ) 
     ^ write(nLSCcom2, 
     ^         '(''  , PLOT ARRAY IS FILLED '' )'
     ^          )
 
c     -                                 Fill Arrays of The Psi Surfaces  IF
      if (iFillPsi .eq. 1) then
      PsiVal = PsiLim
     ^  -0.05*(PsiLim-PsiMin)
c    ^  -0.03*(PsiLim-PsiMin) ! old reliable
c     .                                 Rmag not Rmaj
c     .                                 The 0.95 stays away avoids confusion
c     .                                 at the exact center where there can be
c     .                                 a tiny dip in psi (numerical noise).
      RRary(1) = Rmag * 0.95
      ZZary(1) = 0.
      call PsiSur ( PsiVal , RRary , ZZary , NPLTDIM , Npts )
      RRary(Npts) = RRary(1)
      ZZary(Npts) = ZZary(1)
          rmaxx=Rmaj
          rminn=Rmaj
          zmaxx=0.
          ipsisur=1
          npsipts(ipsisur)=Npts
      do 5 i=1,Npts
          if(rrary(i).gt.rmaxx)rmaxx=rrary(i)
          if(rrary(i).lt.rminn)rminn=rrary(i)
          if(abs(zzary(i)).gt.zmaxx)zmaxx=abs(zzary(i))
          rpsi(ipsisur,i) = RRary(I) - Rmaj
          zpsi(ipsisur,i) = ZZary(I)
5     continue
 
      PsiVal = PsiLim
     ^  -0.30*(PsiLim-PsiMin)
c                                       Rmag not Rmaj
      RRary(1) = Rmag * 0.95
      ZZary(1) = 0.
      call PsiSur ( PsiVal , RRary , ZZary , NPLTDIM , Npts )
      RRary(Npts) = RRary(1)
      ZZary(Npts) = ZZary(1)
          ipsisur=2
          npsipts(ipsisur)=Npts
      DO 6 I=1,Npts
          rpsi(ipsisur,i) = RRary(I) - Rmaj
          zpsi(ipsisur,i) = ZZary(I)
 6    continue
 
      PsiVal = PsiLim
     ^  -0.70*(PsiLim-PsiMin)
c                                       Rmag not Rmaj
c     RRary(1) = Rmag * 0.90            0.90 might be needed for GA D-III-D
      RRary(1) = Rmag * 0.90
      ZZary(1) = 0.
 13   call     plasma2d (RRary(1),ZZary(1), psi,
     ^                   Br,Bz,RBphi,omc,Tee,pe2,pi2,aio,ael)      
      if (psi .gt. PsiVal .and. 
     ^    RRary(1) .eq. 0.90*Rmag ) then
        RRary(1) =  0.5*(RRary(1) + Rmag)
        goto 13
      endif

      call PsiSur ( PsiVal , RRary , ZZary , NPLTDIM , Npts )
           if (iError .gt. 0)  return

      RRary(Npts) = RRary(1)
      ZZary(Npts) = ZZary(1)
          ipsisur=3
          npsipts(ipsisur)=Npts
      DO 7 I=1,Npts
          rpsi(ipsisur,i) = RRary(I) - Rmaj
          zpsi(ipsisur,i) = ZZary(I)
 7    continue
 
C     q(Psi)    = RBphi(Psi)/TWOPI * Integral dSpol/(R**2 Bpol)
C     Curnt(MA) =   10/FourPi * Integral dSpol * Bpol
      Qval      = 0.
      Cval      = 0.
      ipsisur   = 1
      Npts      = npsipts(ipsisur)
      Do 8    I = 2, Npts
      dR  = rpsi(ipsisur,i) - rpsi(ipsisur,(i-1))
      dZ  = zpsi(ipsisur,i) - zpsi(ipsisur,(i-1))
      dS  = sqrt ( dR**2 + dZ**2 )
       R  = Rmaj + ( rpsi(ipsisur,i) + rpsi(ipsisur,i-1) )/2.
       Z  =        ( zpsi(ipsisur,i) + zpsi(ipsisur,i-1) )/2.
      call     plasma2d (r,z, psi,Br,Bz,RBphi,omc,Tee,pe2,pi2,aio,ael)
      Bpol = SQRT ( Br**2 + Bz**2 )
      Qval = Qval + dS/(Bpol*R**2 )
      Cval = Cval + dS* Bpol
8     Continue
      Qval = Qval * RBphi  /    TWOPI
      Cval = Cval * 10/(2.*TWOPI)
      qlim = Qval
      q0   = 1.
c     -                                 finished filling surface arrays


c     -                                 write the file now
c            open (nTSCunus,status='unknown',file = FileNa)
c            do 6001 i=1,NPSISUR
c               write(nTSCunus,5600) npsipts(i)
c               do 6000 j=1,npsipts(i)
c                  write(nTSCunus,5601) rpsi(i,j), zpsi(i,j)
c 6000          continue            
c 6001       continue
c 5600   format(i3)
c 5601   format(2e15.8)
c 5602   format(3e15.8)
c
c            write(nTSCunus,5602) rminn, rmaxx, zmaxx
c            write(nTSCunus,5602) qlim,  q0   , Cval
c            close(nTSCunus)
      endif
c     .                                 ENDIF on finding psi surfaces ENDIF
c
c
c    -                                  The psi surfaces used in plotting
c    -                                  are now defined.
c
c    -                                  First page of ray plots:
c    -                                  Isometric of ray in the torus:
c    -
      call EZinit
      xtor = zmaxx + rmaxx * R1O2
      if ( rmaxx*R3O2 .gt. xtor ) xtor = rmaxx*R3O2
      call EZsets ( 620, 970,   35,385 ,
     ^            -xtor,xtor,-xtor,xtor, 1 )
c     call GNsets ( 620, 970,   35,385 ,
c    ^            -xtor,xtor,-xtor,xtor, 1 )
      do 20 j=1,12
      csx = cos (TWOPI/12.*float(j-1) + PIO4 )
      csy = cos (TWOPI/12.*float(j-1) - PIO4 )
      ipsisur=1
      Npts   =npsipts(ipsisur)
      do 10  i=1,Npts
      xp(i) = r3o2*(rmaj+rpsi(ipsisur,i))*csx
10    yp(i) =-r1o2*(rmaj+rpsi(ipsisur,i))*csy
     ^                  +zpsi(ipsisur,i)
      call ezcurv (xp,yp,npts)
c     call GNcurv (xp,yp,npts)
20    continue
      cosa = cos(alpha)
      sina = sin(alpha)
      do 50   i=1,iplt
      xp(i) =          cosa*yrr(i)*(cos(ypp(i)) - sin(ypp(i)))
50    yp(i) = yzz(i) - sina*yrr(i)*(cos(ypp(i)) + sin(ypp(i)))
      call EZcurv (xp,yp,iplt)
      write(MyString, '('' Ray '',i2,''$'')') iray
      call EZwrit(850,45, MyString, 0,0)
      write(MyString, '(''MA:'',f6.2,''$'')') Cval
      call EZwrit(650,335, MyString, 0,0)
      write(MyString, '(''Bt:'',f6.2,''$'')') Btesl
      call EZwrit(820,335, MyString, 0,0)
100   continue
c     -                                 Ray path in poloidal cross section:
      xpol = amax1( zmaxx , rmaj-rminn , rmaxx-rmaj )
      call EZrnd2 ( xpol, xpol, ipol, ipoli )
      call EZsets ( 700,  950,  425,  675,
     ^            -xpol, xpol,-xpol, xpol, 1  )
      call GNsets ( 680, 1020,  380,  720,
     ^            -xpol, xpol,-xpol, xpol, 1  )
      ipsisur=1
      Npts=npsipts(ipsisur)
      do 105 i=1,Npts
         xxp(i) = rpsi(ipsisur,i)
         yyp(i) = zpsi(ipsisur,i)
105   continue
      call EZpnts( xxp,yyp,Npts)
      call GNpnts( xxp,yyp,Npts)
      ipsisur=2
      Npts=npsipts(ipsisur)
      do 106 i=1,Npts
         xxp(i) = rpsi(ipsisur,i)
         yyp(i) = zpsi(ipsisur,i)
106   continue
      call EZpnts (xxp,yyp,Npts)
      call GNpnts (xxp,yyp,Npts)
      ipsisur=3
      Npts=npsipts(ipsisur)
      do 107 i=1,Npts
         xxp(i) = rpsi(ipsisur,i)
         yyp(i) = zpsi(ipsisur,i)
107   continue
      call EZpnts( xxp,yyp,Npts )
      call GNpnts( xxp,yyp,Npts )

      do 110 i=1,iplt
      xp(i) = yrr(i) - rmaj
110   yp(i) = yzz(i)
      call EZcurv ( xp , yp , iplt )
      call GNcurv ( xp , yp , iplt )
      call EZcros( (Rmag-Rmaj), zmag, 1 )
      call EZaxes (ipol, ipoli, ipol, ipoli)
      call Find4Dmp(dlnPdsX(1,iray), izone, icross ,nfound)
c
      do 112 i=1,nfound
      call EZcros(  (RofRay(icross(i))-Rmaj), 
     ^               ZofRay(icross(i)),        1       )
 112  continue
c     
c     -                                 Nper vs sqrt of psi:
      call EZsets ( 100, 350,  75, 325,
     ^             ZERO, ONE,ZERO, pernx, 1 )
c    ^              0.0, 1.0, 0.0, pernx, 1 )
      call GNsets (   0, 340,   0, 380,
     ^             ZERO, ONE,ZERO, pernx, 1 )
      call EZwrit ( 100, 335,' Nper vs rt-psi $',0,0   )
      call GNtitl (          ' Nper vs rt-psi $'       )
      call EZwrit ( 100, 300,' ~150 -->NB damp$',0,0   )
c     call GNwrit ( 100, 300,' ~150 -->NB damp$',0,0   )
      woc = sqrt(woc2)
      do 120 i=1,iplt
        xxp(i) = yps(i)
         xp(i) = ypr(i)
         yp(i) = ypl(i)
 120  continue
c
c     -         Temp fix for counting problems
                xxp(1)=xxp(2)
                 xp(1)= xp(2)
                 yp(1)= yp(2)
c     -         Temp fix for counting problems
c
      call EZcurv (xxp, xp, iplt )
      call GNcurv (xxp, xp, iplt )
      call EZaxes ( incx,incxi,inc, 10/inc )
c
c     -                                 Npar vs sqrt of psi:
      call EZsets ( 100, 350, 425, 675,
     ^             ZERO, ONE, -parnx, parnx, 1 )
c    ^              0.0, 1.0, -parnx, parnx, 1 )
      call GNsets (   0, 340, 380, 760,
     ^             ZERO, ONE, -parnx, parnx, 1 )
      call EZcurv (xxp, yp, iplt )
      call GNcurv (xxp, yp, iplt )
      write(MyString, '(''N_ll:'',f5.2,''   N_po:$'')')yp(1)
      call EZwrit ( 100, 710,MyString,0,0  )
      call GNtitl (          ' Npar vs rt-psi $'       )
      write(MyString, '(''N_to:'',f5.2,
     ^                  ''  '',f5.1,''$'')')enpar,enpol
      call EZwrit ( 100, 685,MyString,0,0  )

      call EZaxes ( incx,incxi,inc, 10/inc )

c     -                                 Npar of good damping vs sqrt of psi:
c     
c     .                                 Indicates where damping is expected
c     .                                 Nll = sqrt(511kev/Tekev) / 3.5
c     .                                 w/kv less than 4 ... some damping
c     .                                 w/kv less than 3 ... pretty strong
c     w/kv      zet^3 exp(-zet^2)
c      1.             .21000
c      1.7            .41000   (max!)
c      2.             .37000
c      3.             .11000
c      3.5            .03300   (use this value for Landau damping indication)
c      4.             .00700
c      5.             .00010
      do 130 i=1,NpsiJ
         xxp(i) = ( PsiVec(i)-PsiVec(1) )/( PsiVec(NpsiJ)-PsiVec(1) )
         if (xxp(i) .lt. 0.00) then
           write(MyString,'(''PsiNorm <0 in PlRay, i='',i3)')i
           call LSCwarn(MyString)
         endif
         xxp(i) = sqrt( abs(xxp(i)) )
          yp(i) = 6.5/sqrt(TeeVec(i)+0.01)
         yyp(i) =-6.5/sqrt(TeeVec(i)+0.01)
         if (yp(i) .gt. parnx) go to 131
 130  continue

 131  call EZpnts (xxp, yp, i )
      call EZpnts (xxp,yyp, i )
      call GNpnts (xxp, yp, i )
      call GNpnts (xxp,yyp, i )

c
c     -                                 Quantities having to do with damping
c     -                                 and polarization
c     -
      if (scatKdeg .le. 0.001) then   
c
         continue
c        May 2000, code taken out, placed in Nth-Nrho-snip.F
c        That code was for NJ Fisch for alpha channeling
c
      else if (scatKdeg .gt. 0.001) then

c     -                                 Incident and scattered theta plots
c     -                                 if we have scattering.
      do 300 i=1,iscatplt
         xp(i) = float(i)
         yp(i) = inciThet(i)
        yyp(i) = scatThet(i)
 300  continue
      nicemx = xp(iscatplt)
      if(nicemx .gt. float(NPLTDIM)/4.0) then
        nicemx = float(NPLTDIM)
      else if (nicemx .lt. 10.) then
        nicemx = 10.
        i      = 1
        j      = 10
      else
        call EZrnd2(nicemx, nicemx, i,j)
      endif
      call EZsets ( 425, 600,  75, 325,
     ^           ZERO, nicemx, ZERO, ONE80, 1 )
c    ^            0.0, nicemx, 0.0 , 180., 1 )
c     call EZaxes (i,j,2,3)
      call EZaxes (i,j,2,1)
      call EZpnts (xp, yp,iscatplt)
      call EZcros (xp,yyp,iscatplt)
c     call EZwrit ( 425, 335, 'inThet. scatThet crs$',0,0)
      call EZwrit ( 425, 335, 'Thet i/o ./x$',0,0)

      call EZsets ( 425, 600, 425, 675,
     ^             ZERO, ONE80,ZERO,ONE80, 1)
c    ^              0.0, 180., 0.0 , 180. ,1)
c     call EZaxes (2,3,2,3)
      call EZaxes (2,1,2,1)
      call Ezcros (yyp, yp,iscatplt)
c     call EZwrit ( 425, 685,'Scatt(x) for Inci(y) $',0,0  )
      call EZwrit ( 425, 710,'Scat(x) for $',0,0  )
      call EZwrit ( 425, 685,'Inci(y)$',0,0  )

      endif
 
      igraph = igraph + 1
      call MkGrfLst(' Ray plots in r and k spaces  ')
      call EZfini(0,0)
c     -    EZfini(0,0)  first 0 means more graphs coming; second 0 ignored
c
           call GNfini
      if (iDoAcces .eq. 1) then
        iDoAcces = 0   
        igraph = igraph + 1
        ep = .005
        call AccesiSB(RlcfsMin-ep,  RlcfsMax+ep,
     ^              -(ZlcfsMax+ep),+ZlcfsMax+ep,  Rmag)
        call MkGrfLst   (' Cntrs  psi, access, enhance')
      endif  
      return
      END
c     .                                                                |
c     .                                                                |
C     PlRay     ends                        ---------------------------|

c     -----------------------------------------------------------------

      SUBROUTINE Find4Dmp(y, n, i4, nfound)
#include "Implic.inc"
      INTEGER i, n, i4(4), j, nfound
      REAL    lvl(4)
      REAL    y(n), dum, MxdPdz, start
      DATA    MxdPdZ, lvl(1), lvl(2), lvl(3), lvl(4)
     ^      / 0.0001,   0.75,  0.50 ,  0.25 , 0.10  /

      nfound = 1
      start = 1.
      j = 1
      do 5 i=1,4
         i4(i) = n
 5    continue

      do 10 i=2,n
          dum = 1. + y(i)
c                                        Limit the damping per zone to the
c                                        value MxdPdZ
          if (dum .lt. MxdPdz) then
            dum = MxdPdZ
          endif
          start =  start * dum
          if (start .le. lvl(j) ) then
            i4(j) = i
            j=j+1
          endif
          if (j .eq. 5) go to 11
 10   continue

      nfound = j
      return
      
 11   continue
      nfound = 4
      return
      END
c     -----------------------------------------------------------------
      SUBROUTINE FirstPas
#include "Implic.inc"
#include "params.inc"
#include "tscunits.inc"
#include "RayBins.inc"
      INTEGER NmPts, ThisPlot, TotlPlts, PltsOnPg, PltIndx
      INTEGER ir, iz, ip, iv, i
      PARAMETER (PltsOnPg =6)
      INTEGER xlow(PltsOnPg) , xhigh(PltsOnPg)
      INTEGER ylow(PltsOnPg) , yhigh(PltsOnPg)
      INTEGER ydrop(PltsOnPg), ywrit(PltsOnPg), ytitl

      INTEGER ixlo(PltsOnPg) , ixhig(PltsOnPg)
      INTEGER iylo(PltsOnPg) , iyhig(PltsOnPg)
      INTEGER iydro(PltsOnPg), iywri(PltsOnPg), iytit

      CHARACTER*20 MyString
      DATA    (xlow(i) , i=1,PltsOnPg)  /  50,400, 750, 50,400, 750 /
      DATA    (xhigh(i), i=1,PltsOnPg)  / 300,650,1000,300,650,1000 /
      DATA    (ylow(i) , i=1,PltsOnPg) /  400,400, 400, 50, 50,  50 /
      DATA    (yhigh(i), i=1,PltsOnPg) /  650,650, 650,300,300, 300 /
      DATA    (ywrit(i), i=1,PltsOnPg) /  625,625, 625,275,275, 275 /
      DATA    (ydrop(i), i=1,PltsOnPg) /  600,600, 600,250,250, 250 /
      DATA     ytitl                   /  700 /

      DATA    (ixlo(i) , i=1,PltsOnPg)  /   0,340, 680,  0,340, 680 /
      DATA    (ixhig(i), i=1,PltsOnPg)  / 340,680,1020,340,680,1020 /
      DATA    (iylo(i) , i=1,PltsOnPg) /  380,380, 380,  0,  0,   0 /
      DATA    (iyhig(i), i=1,PltsOnPg) /  680,680, 680,300,300, 300 /
      DATA    (iywri(i), i=1,PltsOnPg) /  700,700, 700,320,320, 320 /
      DATA    (iydro(i), i=1,PltsOnPg) /  675,675, 675,295,295, 295 /
      DATA     iytit                   /  750 /


      REAL     RtPsi(NZONDIM), RelPower(NZONDIM)
      INTEGER  iPin1, iPout1, iPin2, iPout2, iPin3, iPout3, iPctr
      INTEGER  iZin1, iZout1, iZin2, iZout2, iZin3, iZout3
      REAL      rpsi
      REAL      Pin1,  Pout1,  Pin2,  Pout2, Pin3, Pout3, Pmaxi
      DATA      Pin1,  Pout1,  Pin2,  Pout2, Pin3, Pout3, Pmaxi /
     ^          1.15,   1.12,  1.09,   1.06, 1.03,  1.00,  1.5  /
c     iPctr     integer Psi counter  1: in 1st pass; 2: out 1st pass
c     iPctr     integer Psi counter  3: in 2nd pass; 4: out 2nd pass
c     iPctr     integer Psi counter  5: in 3rd pass; 6: out 3rd pass or later

      REAL
     ^        ZERO, ONE, RE81, RE82
      DATA ZERO, ONE/
     ^      0.0, 1.0/

      rpsi = float ( npsi )
      TotlPlts = nrays

      do 20 ir=1,nrays
      ThisPlot = ir

      PltIndx = mod(ThisPlot-1, PltsOnPg) + 1
      if (ThisPlot .eq. 1 ) then
        call EZinit
        call GNinit(nTSCgraf)
      endif
c

      iPctr = 1
      iPin1 = npsi
      do 10 iz = 1, nzones
      NmPts = iz
      ip = izind(iz,ir)
      iv = ivind(iz,ir)

      RtPsi(iz) = sqrt ( float(ip) / rpsi )
      RelPower(iz) = power(iz,ir)/power(1,ir)
      if ( RelPower(iz) .le. 0.01 .or. iv .eq. 0 ) go to 11
c
      if (iPctr .eq. 1 ) then
      if ( ip .le. iPin1 ) then
        if(RelPower(iz) .ge. 0.99) RelPower(iz) = Pin1
        iPin1 = ip
        iZin1 = iz
        iPctr = 1
      else 
        if(RelPower(iz) .ge. 0.99) RelPower(iz) = Pout1
        iPout1= ip
        iZout1= iz
        iPctr = 2
      endif

      else if (iPctr .eq. 2 ) then
      if ( ip .ge. iPout1 ) then
        if(RelPower(iz) .ge. 0.99) RelPower(iz) = Pout1
        iPout1 = ip
        iZout1 = iz
        iPctr  = 2
      else 
        if(RelPower(iz) .ge. 0.99) RelPower(iz) = Pin2
        iPin2  = ip
        iZin2  = iz
        iPctr = 3
      endif

      else if (iPctr .eq. 3 ) then
      if ( ip .le. iPin2 ) then
        if(RelPower(iz) .ge. 0.99) RelPower(iz) = Pin2
        iPin2 = ip
        iZin2 = iz
        iPctr = 3
      else 
        if(RelPower(iz) .ge. 0.99) RelPower(iz) = Pout2
        iPout2= ip
        iZout2= iz
        iPctr = 4
      endif

      else if (iPctr .eq. 4 ) then
      if ( ip .ge. iPout2 ) then
        if(RelPower(iz) .ge. 0.99) RelPower(iz) = Pout2
        iPout2 = ip
        iZout2 = iz
        iPctr  = 4
      else 
        if(RelPower(iz) .ge. 0.99) RelPower(iz) = Pin3
        iPin3  = ip
        iZin3  = iz
        iPctr = 5
      endif

      else if (iPctr .eq. 5 ) then
      if ( ip .le. iPin3 ) then
        if(RelPower(iz) .ge. 0.99) RelPower(iz) = Pin3
        iPin3 = ip
        iZin3 = iz
        iPctr = 5
      else 
        if(RelPower(iz) .ge. 0.99) RelPower(iz) = Pout3
        iPout3= ip
        iZout3= iz
        iPctr = 6
      endif

      endif

 10   continue
 11   continue

      call EZsets ( xlow(PltIndx), xhigh(PltIndx),
     ^              ylow(PltIndx), yhigh(PltIndx),
     ^             ZERO, ONE , ZERO,  Pmaxi, 1)
c    ^              0.0, 1.0 ,  0.0,  Pmaxi, 1)

      call GNsets ( ixlo(PltIndx), ixhig(PltIndx),
     ^              iylo(PltIndx), iyhig(PltIndx),
     ^             ZERO, ONE , ZERO,  Pmaxi, 1)

      if ( PltIndx .eq. PltsOnPg .or. ThisPlot .eq. TotlPlts ) then
        call EZwrit(xlow(1),ytitl,
     ^    ' Q-L absorption vs root psi for 6 rays$',0,0) 
        call GNwrit(ixlo(1),iytit,
     ^    ' Q-L absorption vs root psi for 6 rays$',0,0) 

        call MkGrfLst(' Q-L absrpn vs root psi 6 rays')
      endif

c     call EZaxes ( 1,10,1,15 )
      call EZaxes ( 1, 5,3,1)

      write(MyString,'('' Ray '',i2,''$'')') ThisPlot
      call EZwrit(xlow(PltIndx),ywrit(PltIndx),  MyString , 0,0 )
      call GNwrit(ixlo(PltIndx),iywri(PltIndx),  MyString , 0,0 )
      write(MyString,'('' Nll '',f5.2,''$'')') npar(1,ThisPlot)
      call EZwrit(xlow(PltIndx),ydrop(PltIndx),  MyString , 0,0 )
      call GNwrit(ixlo(PltIndx),iydro(PltIndx),  MyString , 0,0 )

      call EZpnts (RtPsi,RelPower,NmPts)
      call GNpnts (RtPsi,RelPower,NmPts)
c
c
      if ( PltIndx .eq. PltsOnPg .or. ThisPlot .eq. TotlPlts ) then
        call EZwrit(xlow(1),ytitl,
     ^    ' Q-L absorption vs root psi for 6 rays$',0,0) 
        call GNwrit(ixlo(1),iytit,
     ^    ' Q-L absorption vs root psi for 6 rays$',0,0) 

        call MkGrfLst(' Q-L absrpn vs root psi 6 rays')

        call EZfini(0,0)
        call GNfini
      endif

 20   continue
      return
      END
c     -----------------------------------------------------------------
      SUBROUTINE PsiSur ( PsiVal , Rary , Zary , ISIZE , Npts )
#include "Implic.inc"
      EXTERNAL plasma2d
C     Finds surfaces of constant Psi, such that the flux on a
C     surface is PsiVal.  The first element of the array shows
C     how to start looking.  It moves to small  r  from the given
C     value until a Psi is correct; then it moves along B
C     to find the next value.
      CHARACTER*70 ErrMsg
      INTEGER i, ISIZE, Npts, NSCALE
      REAL    Bpol, deltf, deltS, f, fs, f1, f2,
     ^        HUGE,
     ^        PsiVal, r0, r1, r2, Rstart, Stepr,
     ^                z0, z1, z2, Zstart, Stepz
      REAL
     ^                    r,z, psi,Br,Bz,RBphi,omc,Tee,pe2,pi2,aio,ael
      REAL Rary(ISIZE), Zary(ISIZE)
      DATA HUGE /1.0e+30/
      Rstart= Rary(1)
      Zstart= Zary(1)
c     NSCALE= ISIZE divided by something like 3 or 4; 24/7 for a while. 5 Now.
c     NSCALE= ISIZE * 7 / 24 worked for a long time.  D-III-D needed 1/5
      NSCALE= ISIZE * 1 /  5

      Npts  = 1
      deltS = Rstart/float(NSCALE)
      r     = Rstart
      z     = Zstart
      call     plasma2d (r,z, psi,Br,Bz,RBphi,omc,Tee,pe2,pi2,aio,ael)
      fs = Psi - PsiVal
 
      do 10 i=1, NSCALE
      r     = Rstart - deltS
      call     plasma2d (r,z, psi,Br,Bz,RBphi,omc,Tee,pe2,pi2,aio,ael)
      if ( Psi .ge. HUGE ) return
      f = Psi - PsiVal
c
c     .                                 If zero crossing, kick out
      if((f.gt.0..and.fs.le.0.).or.
     ^   (f.lt.0..and.fs.ge.0.))    go to 12
c
c     .                                 If we seem to be going away from
c     .                                 the zero crossing, then we must have
c     .                                 gone thru an extremum; kick out
      if( abs(f) .ge. abs(fs)  ) then
        write(ErrMsg,'(
     ^''leaving 0-crossing at R,Psi,PsiVal:'',
     ^  3(1x,1pe9.2))') r, psi, psival
        call LSCwarn(ErrMsg)
        go to 25
      else
        fs    = f
      endif
   10 Rstart= r
      write(ErrMsg,'(''no start point in PsiSur '',
     ^               ''R,Psi,PsiVal:'', 3(1x,1pe9.2))') 
      call LSCwarn(ErrMsg)
      return
 
   12 continue
      deltf = fs-f
      if (deltf .eq. 0.) then
        call LSCwarn( ' fs=f in PsiSur')
      else
        Rstart= Rstart - deltS * fs/(fs-f)
      endif
 25   r0    = Rstart
      z0    = Zstart
      Npts = 1
      Rary(Npts) = Rstart
      Zary(Npts) = Zstart
 
      do 30 i=2,ISIZE
      call     plasma2d (r0,z0, psi,Br,Bz,RBphi,omc,Tee,pe2,pi2,aio,ael)
      Bpol  = sqrt( Br*Br + Bz*Bz )
      Stepr = deltS * Br/Bpol
      Stepz = deltS * Bz/Bpol
c
c     .                                 Take a step along the field line
      r     = r0 + Stepr
      z     = z0 + Stepz
c     .                                 Take a tiny step perp to the last one
c     .                                 First outward from the plasma ...
c     .                                 assuming current in phi direction
      r1    = r  + Stepz/10.
      z1    = z  - Stepr/10.
c     .                                 Take a tiny step the other way..inward
      r2    = r  - Stepz/10.
      z2    = z  + Stepr/10.
c     .                                 We have 3 points in a line, all 
c     .                                 pretty near the right place.
c     .                                 Find the point with the smallest 
c     .                                 error
      call     plasma2d (r ,z , psi,Br,Bz,RBphi,omc,Tee,pe2,pi2,aio,ael)
        f  = abs(psi-PsiVal)
      call     plasma2d (r1,z1, psi,Br,Bz,RBphi,omc,Tee,pe2,pi2,aio,ael)
        f1 = abs(psi-PsiVal)
      call     plasma2d (r2,z2, psi,Br,Bz,RBphi,omc,Tee,pe2,pi2,aio,ael)
        f2 = abs(psi-PsiVal)
c
        fs=amin1(f,f1,f2)
c     .                                 The point labeled '2' is preferred be-
c     .                                 cause it tends to be in the plasma
      if (f2 .eq. fs) then
        r = r2
        z = z2
      else if (f1 .eq. fs) then
        r = r1
        z = z1
      endif
c
      Npts = i
      Rary(Npts) = r
      Zary(Npts) = z
      if( i .gt. 5 .and.
     ^ (r-Rstart)**2+(z-Zstart)**2 .lt. 4.0*deltS**2) return
      r0=r
   30 z0=z
      write(ErrMsg,'(''no closed psi; i,R,Z,Psi:'',
     ^ i5,3(1x,1pe9.2) )') npts, r, z, psi
      call LSCwarn(ErrMsg)
      return
      END
c
c     -----------------------------------------------------------------
c
c     AccesiSB.F                        -------------------------------|
c                                                                      |
c                                                                      |
      SUBROUTINE AccesiSB (r1,r2, z1,z2, Rmag)
c     .                                 Makes contour plot of psi surfaces
c     .                                 and accessibility surfaces
c     .                                 and n_\parallel enhancement surfaces
c     .                                 PsiContr AccContr EnhContr 
c     AccContr uses the classic accessibility formula
c      n_//_for_accessibility >= sqrt(Epar) + omega_pe/omega_ce
c     EnhContr uses a form recently derived by Kupfer, Moreau, Ono, Takahashi
c     as follows:
c      n_// == n_tor Btor/Btot + n_pol Bpol/Btot; 
c      n_tor = n_//_0 R_launch_point/R
c      n_pol <= n_perp = n_// omega_pe/omega/sqrt(Epar)!electrostatic estimate
c
c     n_// <= n_//_0  { (R_launch / R)  / 
c                     [1 - (Bpol/Btot) (omega_pe/omega) / sqrt(Epar)] }
c     .                                 EnhContr == {}
#include "Implic.inc"
#include "params.inc"
#include "RayBins.inc"
#include "dielec.inc"

      REAL    r1, r2, z1, z2, Rmag

c
c     Here are variables used in the contour plot:
      CHARACTER*30 MyString
      INTEGER kclev1, kclev2, i1stdim,j2nddim,
     ^                                  ixmin, ixmax, ixstep,
     ^                                  jymin, jymax, jystep
      INTEGER nCntrDim,nPnts
      PARAMETER (i1stdim=50, j2nddim=50)
      PARAMETER (nPnts=i1stdim*j2nddim)
      PARAMETER (ixmin =1 ,jymin =1,  kclev2=1)
      PARAMETER (ixstep=1 ,jystep=1 )
      PARAMETER (nCntrDim=50)
      REAL    PsiContr(i1stdim,j2nddim)
      REAL    AccContr(i1stdim,j2nddim)      
      REAL    EnhContr(i1stdim,j2nddim)      
      REAL    Rpunct, Npunct
      REAL    xAry(i1stdim), xa, xb, xdumy
      REAL    yAry(j2nddim), ya, yb
      REAL    clevelin(nCntrDim), ContrMin, ContrMax
c     Here are variables for this subroutine
      REAL 
     ^                  r0,z0, psi,Br,Bz,RBphi,omc,Tee,pe2,pi2,aio,ael,
     ^                  Bpol, Btot, BpolAry(i1stdim), BpolMax,
     ^                  psiNorm, psiEdge, psiCent, AccMax
c     REAL               r0,z0, psi,Br,Bz,RBphi,omc,Tee,pe2,pi2,aio,ael
c     REAL    Bpol, Btot, BpolAry(i1stdim), BpolMax
c     REAL    psiNorm, psiEdge, psiCent, AccMax
      INTEGER i, j, k
      INTEGER ix1(4), ix2(4), jy1(4), jy2(4)
c
c     Location reminder:
c     3 = up  left   4 = up  right
c     1 = low left   2 = low right
c     ------------------------------------------------------------------
      DATA    ix1(1),ix2(1),ix1(2),ix2(2),ix1(3),ix2(3),ix1(4),ix2(4) / 
     ^          150,   400,   650,   900,   150,   400,   650,   900  /
      DATA    jy1(1),jy2(1),jy1(2),jy2(2),jy1(3),jy2(3),jy1(4),jy2(4) /
     ^           75,   325,    75,   325,   450,   700,   450,   700  /

      REAL
     ^        ZERO, ONE, RE81, RE82
      DATA ZERO, ONE/
     ^      0.0, 1.0/

c  round up from max found--> nice value; #major divns; #minor divns
      call EZrnd2 (r2,xb, i,j)
      call EZrnd2 ((xb-r1), xdumy, i,j)
      call EZrnd2 (z2,yb, i,j)
      if (2.*yb .gt. xdumy) then
        xa = xb - 2.0*yb
        ya = - yb
      else
        xa = xb - xdumy
        yb = xdumy / 2.
        ya =-yb
      endif

c     Fill arrays at points where data is given
      do 10 i = 1, i1stdim
        xAry(i) = r1 + float(i-1)*(r2-r1)/(float(i1stdim)-1)
 10   continue
      do 11 j = 1, j2nddim
        yAry(j) = z1 + float(j-1)*(z2-z1)/(float(j2nddim)-1)
 11   continue  
c
c     .                                 Get a normalization for psi
         call plasma2d(r2,ZERO,psi,Br,Bz,RBphi,omc,Tee,pe2,pi2,aio,ael)
c        call plasma2d (r2,0., psi,Br,Bz,RBphi,omc,Tee,pe2,pi2,aio,ael)
         psiEdge = 0.98*psi
        call plasma2d(Rmag,ZERO,psi,Br,Bz,RBphi,omc,Tee,pe2,pi2,aio,ael)
c       call plasma2d(Rmag,0.,psi,Br,Bz,RBphi,omc,Tee,pe2,pi2,aio,ael)
         psiCent = psi
         psiNorm = (psiEdge-PsiCent)
c
         AccMax = 1.0
         BpolMax= 0.0
      do 20 i = 1, i1stdim
          r0 = xAry(i) 
c          radPaoletti(i) = xAry(i)
        do 19 j = 1, j2nddim
          z0 = yary(j) 
c          zeePaoletti(j) = yAry(j) 

          call plasma2d (r0,z0, psi,Br,Bz,RBphi,omc,Tee,pe2,pi2,aio,ael)
c     .                                 If outside the plasma set nAcc to 1 
c     .                                 otherwise find the accesible nAcc
          if (psi .ge. psiEdge) then
            PsiContr(i,j) = 1.
            AccContr(i,j) = 1.
            EnhContr(i,j) = 1.
            Bpol = 0.0
c            rpsPaoletti(i,j) = sqrt(PsiContr(i,j))
c            ompPaoletti(i,j) = 0.00
c            BthPaoletti(i,j) = 0.00
c            BphPaoletti(i,j) = 0.00
          else  
            PsiContr(i,j) = (psi-psiCent)/psiNorm
            call eps (r0, z0, 0., 0.)
            AccContr(i,j) = sqrt( pe2/(omc*omc) ) + sqrt(Eper)
            Bpol = sqrt ( Br*Br + Bz*Bz )
            Btot = sqrt ( Bpol*Bpol + RBphi*RBphi/r0/r0 )
            EnhContr(i,j) = ( r0/r2 ) * ( 1.
     ^                       -sqrt(abs(1.-Epar))*
     ^                       Bpol/Btot/sqrt(abs(Eper))  ) 
     ^                      
            if(EnhContr(i,j) .le. 0.1 ) EnhContr(i,j) = 0.1
            EnhContr(i,j) = 1.00/ EnhContr(i,j)

c            rpsPaoletti(i,j) = sqrt(abs(PsiContr(i,j)))
c            ompPaoletti(i,j) = sqrt( pe2/(omc*omc) ) 
c            BthPaoletti(i,j) = Bpol
c            BphPaoletti(i,j) = abs(RBphi/r0)
          endif

          if(  j .eq. (j2nddim+1)/2 ) then
            BpolAry(i) = Bpol
            if (BpolAry(i) .gt. BpolMax ) BpolMax=BpolAry(i)
          endif
          if (AccContr(i,j) .gt. AccMax) AccMax=AccContr(i,j)
c
 19     continue
 20   continue    
      do 25 i = 1, i1stdim
        BpolAry(i) = BpolAry(i)/BpolMax
 25   continue
c     .                                 END of the preparations to plot


c     .                                 Upper Right Corner (index=4)
c     .                                 Potential n_// Enhancement Mid-Plane
c     .                                 Puncture plot of actual enhancement
c     .
      RE81 = 10.
      call EZsets(ix1(4),ix2(4), jy1(4), jy2(4),
     ^             xa,    xb,   ZERO,    RE81,   1)
      call EZrnd2 (xb-xa,xdumy,i,j)
      call EZaxes(i,j,2,5)
      j = (j2nddim+1)/2
      call EZcurv(xAry(1),EnhContr(1,j),i1stdim)
      call EZwrit( ix1(4), (jy2(4)+50),
     ^            'nll enhance slice$',0,0)
      write(MyString,'(''Bpol/'',f6.3,''T ...$'')')BpolMax
      call EZwrit( ix1(4), (jy2(4)+25),
     ^            MyString            ,0,0)
      call EZcros(xAry(1),BpolAry(1),i1stdim)
c     .                                 Puncture plot begins
c     .                                 Go thru all the points looking for
c     .                                 a crossing of the midplane.  If found,
c     .                                 then put a point at that major radius
c     .                                 with the n// enhancement found there.
      do i = 2, izone
         if ( ZofRay(i)*ZofRay(i-1) .le. 0.00 ) then
           Rpunct = 0.5*(RofRay(i)+RofRay(i-1))
           Npunct = 0.5*(npar(i,iray)+npar(i-1,iray)) / 
     ^                   npar(1,iray)
           call EZpnts(Rpunct,Npunct,1)
         endif
      enddo
c     .                                 Puncture plot ends

c     .                                 Upper Right Corner ENDS
c     .
c     .
c     HELP on contour plot usages:
c     ------------------------------------------------------------------
c     kclev1: >0 --> clevelin contains levels to be used; 
c                    dots for index less than kclev2; 
c                    solid for index greater or equal kclev2
c     kclev1: =0 --> first contour at clevelin(1) with
c                    next one up by clevelin(2), and so on and so on
c     kclev1: <0 --> rcontr to choose -kclev1 equally spaced values between
c                    clevelin(1) and clevelin(2)
c     clevelin:      array of contour levels; this is output if kclev1<0
c     kclev2:        separates dots from solid lines
c
c     call rcontr(kclev1,clevelin,kclev2,  ! describes contour levels
c    ^  AryContr,                          ! the 2d array of values
c    ^  i1stdim,                           ! first dimension of Ary
c    ^  xAry, ixmin, ixmax, ixstep,        ! x and y locations, with ranges
c    ^  yAry, jymin, jymax, jystep )       ! of indexes to be used
c     ------------------------------------------------------------------

      ixmax = i1stdim
      jymax = j2nddim
c     .                                 Lower Left Corner (index = 1)
c     .                                 Psi contours
c     kclev2 =  1 ! by parameter
      ContrMin = 0.01
      ContrMax = 0.99

      kclev1 = 11
      do 30 k=1,kclev1
        clevelin(k) = ContrMin + float(k-1)*(ContrMax-ContrMin)/
     ^                           float(kclev1-1)
 30   continue
      call EZrcon(ix1(1),ix2(1), jy1(1), jy2(1),
     ^             xa,    xb,     ya,     yb   , 
     ^  kclev1,clevelin,kclev2,
     ^  PsiContr,                        
     ^  i1stdim,                         
     ^  xAry, ixmin, ixmax, ixstep,      
     ^  yAry, jymin, jymax, jystep )     
      call EZwrit( ix1(1), (jy2(1)+50),
     ^            'Flux contours$',0,0)
c     .                                 Lower Left Corner ENDS
c     .
c     .
c     .                                 Lower Right Corner (index = 2)
c     .                                 Accessibility Contours
      ContrMin = 1.250
      kclev1 = 15
      do 40 k=1,kclev1
        clevelin(k) = ContrMin + float(k-1)*0.25
 40   continue
      call EZrcon(ix1(2),ix2(2), jy1(2), jy2(2),
     ^             xa,    xb,     ya,     yb   , 
     ^  kclev1,clevelin,kclev2,
     ^  AccContr,                        
     ^  i1stdim,                         
     ^  xAry, ixmin, ixmax, ixstep,      
     ^  yAry, jymin, jymax, jystep )     
      call EZwrit( ix1(2), (jy2(2)+50),
     ^            'nll access cntrs$',0,0)
      call EZwrit( ix2(2), (jy2(2)+50),
     ^            '1.25 strt$',0,0)
      call EZwrit( ix2(2), (jy2(2)+25),
     ^            '0.25 aprt$',0,0)
c     .                                 Lower Right Corner ENDS
c
c
c     .                                 Upper Left Corner (index = 3)
c     .                                 Potential n_// Enhancement Coutours
      kclev1 = 7
      do 50 k=1,kclev1
        clevelin(k) = ( sqrt(2.00) )**float(k)
 50   continue


      call EZrcon(ix1(3),ix2(3), jy1(3), jy2(3),
     ^             xa,    xb,     ya,     yb   , 
     ^  kclev1,clevelin,kclev2,
     ^  EnhContr,                        
     ^  i1stdim,                         
     ^  xAry, ixmin, ixmax, ixstep,      
     ^  yAry, jymin, jymax, jystep )     
      call EZwrit( ix1(3), (jy2(3)+50),
     ^            'nll enhance cntrs$',0,0)
      call EZwrit( ix2(3), (jy2(3)+50),
     ^            'rt 2 strt$',0,0)
      call EZwrit( ix2(3), (jy2(3)+25),
     ^            'rt 2 aprt$',0,0)
c     .                                 Upper Left Corner ENDS
c
c
      call EZfini(0,0)
c
      return
      END
c                                                                      |
c                                                                      |
c     Accesibi.F                        -------------------------------|
c
c     .                                                                |
c     .                                                                |
c     Rayio.F  ends                         ---------------------------|



